function y=impMpr(y0,f,Df,T,Nh)

%step size
h=T/Nh;

%set initial value
y=y0;

%integrate up to end time
for ii=1:Nh

    %Implicit mid-point rule as root-finding problem
    F=@(x) x-y-h*f(y/2+x/2);
    
    %Jacobi matrix of F
    DF=@(x) eye(length(y0))-h*Df(y/2+x/2)/2;
    
    %Newton step
    y=newton(y,F,DF);

end

end
